; GetExpTable by Vortex
; pExpTable : pointer to the EXPORT_TABLE structure that will receive information about DLL's export table

.386
.model flat, stdcall
option casemap:none

include         \GeneSys\include\windows.inc

EXPORT_TABLE    STRUCT
    NumbOfNames         DWORD ? ; number of exported functions
    AddrOfNames         DWORD ? ; address pointing to an array of RVAs of function names
    AddrOfEntryPoints   DWORD ? ; address pointing to an array of RVAs of function etry points
EXPORT_TABLE    ENDS

.code

GetExpTable PROC uses esi hModule:DWORD,pExpTable:DWORD

    mov     esi,pExpTable
    mov	edx,hModule
    add	edx,IMAGE_DOS_HEADER.e_lfanew[edx]
    mov	edx,IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[edx]
    add	edx,hModule

    mov	eax,IMAGE_EXPORT_DIRECTORY.NumberOfNames[edx]
    mov     EXPORT_TABLE.NumbOfNames[esi],eax
  
    mov	ecx,IMAGE_EXPORT_DIRECTORY.AddressOfNames[edx]
    add	ecx,hModule
    mov     EXPORT_TABLE.AddrOfNames[esi],ecx

    mov	ecx,IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals[edx]
    add	ecx,hModule
    movzx   eax,WORD PTR [ecx]
    mov	ecx,IMAGE_EXPORT_DIRECTORY.AddressOfFunctions[edx]
    shl	eax,2
    add	ecx,hModule
    add	ecx,eax	
    mov     EXPORT_TABLE.AddrOfEntryPoints[esi],ecx
    ret		

GetExpTable ENDP

END